#include "texto.h"
#define FORMATO "+-0123456789"

/*
 * Relaciona un caracter con un nmero entero
 */
int obtener_indice (char caracter)
{
    static char * orden_letras="+-0123456789\0";
	int i;
				
	for (i = 0; orden_letras [i]; i ++)
	{
		if (caracter == orden_letras [i])
			return i;
	}
	
	return -1;
}


/*
 * imprime un caracter sobre la superficie dst (generalmente screen)
 */
int imprimir_letra (SDL_Surface * dst, SDL_Surface * ima,int x, int y, char letra)
{
	SDL_Rect srcrect;
	SDL_Rect dstrect = {x, y, 0, 0};
	
	
	srcrect.w=ima->w/12;
	srcrect.x=srcrect.w*obtener_indice(letra);
	srcrect.y=0;
	srcrect.h=ima->h;
	if(srcrect.x>=0)
    	SDL_BlitSurface(ima, &srcrect, dst, &dstrect);
	
	return ima->w/12;
}


/*
 * imprime una cadena de textos completa sobre la superficie referenciada
 * por el primer parmetro
 */
void imprimir_palabra (SDL_Surface * screen, SDL_Surface * ima, int x, int y, char * cadena)
{
	int i;
	int dx = x;

	for (i = 0; cadena [i]; i ++)
		dx += imprimir_letra (screen, ima, dx, y, cadena [i]);
}
void mostrar_msg (SDL_Surface * screen, SDL_Surface * ima, int x,int y, char * formato, ...)
{
    va_list lista;
    char buffer [1024];
    va_start (lista, formato);
        vsprintf (buffer, formato, lista);
        imprimir_palabra (screen, ima, x, y, buffer);
    va_end (lista);
}
